package db

import (
	"encoding/binary"
	"sync"
	"time"
)

var uidState struct {
	mx      sync.Mutex
	ts      uint64
	counter uint16
}

func nextID() []byte {
	b := make([]byte, 10)

	uidState.mx.Lock()
	cur := uint64(time.Now().UnixNano())
	if cur == uidState.ts {
		uidState.counter++
	} else {
		uidState.ts = cur
		uidState.counter = 0
	}
	binary.BigEndian.PutUint64(b[:8], cur)
	binary.BigEndian.PutUint16(b[8:10], uidState.counter)
	uidState.mx.Unlock()

	return b
}
